// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('LoanApplication',
    ['ionic', 'ngCordova',
        'LoanApplication.controllers',
        'LoanApplication.routes',
        'LoanApplication.services',
        'LoanApplication.directives'
    ])

    .run(function($ionicPlatform, $cordovaKeyboard, $cordovaDevice, $ionicConfig, $cordovaAppVersion, $cordovaSplashscreen, $cordovaStatusbar, $cordovaToast, $ionicHistory, $location, $rootScope, $window, $timeout, $http, config) {//$cordovaDevice
        $ionicPlatform.ready(function() {
            $ionicPlatform.isFullScreen = true;

            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                window.cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                window.cordova.plugins.Keyboard.disableScroll(true);
            }

            config.client.device.OS = navigator.userAgent;
            if (!config.isApple){
                $ionicConfig.views.swipeBackEnabled(false);
                $ionicConfig.views.transition('none');
            }

            if (typeof StatusBar != 'undefined' && $cordovaStatusbar){
                $cordovaStatusbar.style($cordovaStatusbar.STYLES.DEFAULT);
            }

            if (typeof String.prototype.endsWith !== 'function') {
                String.prototype.endsWith = function(suffix) {
                    return !suffix?false:(this.toString().indexOf(suffix.toString().trim()) === this.toString().trim().length - suffix.toString().trim().length);
                };
            }
            if (typeof String.prototype.startsWith !== 'function') {
                String.prototype.startsWith = function(suffix) {
                    return !suffix?false:this.toString().indexOf(suffix.toString().trim()) === 0;
                };
            }

            if (typeof cordova != 'undefined' && $cordovaAppVersion) {
                $cordovaAppVersion.getVersionNumber().then(function (versionNumber) {
                    if (versionNumber){
                        config.client.version = versionNumber;
                    }
                });
                $cordovaAppVersion.getAppName().then(function (appName) {
                    if (appName){
                        config.client.appName = appName;
                    }
                    getAppProduct();
                });
            }

            if (typeof device != 'undefined' && $cordovaDevice) {
                config.client.device.OS = $cordovaDevice.getPlatform() + " " + $cordovaDevice.getVersion();
                config.client.device.model = $cordovaDevice.getManufacturer() + " " + $cordovaDevice.getModel();
                config.client.device.UUID = $cordovaDevice.getUUID();

                config.isApple = /\(i[^;]+;( U;)? CPU.+Mac OS X/i.test(config.client.device.OS) || /(iPhone)|(iPod)|(ios)|(mac)|(ipad)|(iwatch)|(apple)/i.test(config.client.device.OS);

                $ionicConfig.scrolling.jsScrolling(false);

                if (!config.isApple) {
                    $ionicConfig.views.swipeBackEnabled(false);
                    $ionicConfig.views.transition('none');
                }
            }

            var initUmeng = function () {
                if (typeof Umeng == 'undefined'){
                    return;
                }

                if (!config.appProduct || !config.appProduct.appConfig || !config.appProduct.appSource){
                    $timeout(initUmeng, 2000);
                    return;
                }

                if (!config.isApple) {
                    Umeng.AndroidInit(config.appProduct.appConfig.umeng_android_app_key, config.appProduct.appSource.source_constant);
                    var getAndroidDeviceIdCallback = function (result) {
                        if (result.length == 0){
                            $timeout(function(){Umeng.getAndroidDeviceId(getAndroidDeviceIdCallback);}, 1000);
                        }else{
                            config.client.device.IMEI = result;
                        }
                    };
                    Umeng.getAndroidDeviceId(getAndroidDeviceIdCallback);
                }else{
                    Umeng.init(config.appProduct.appConfig.umeng_ios_app_key, config.appProduct.appSource.source_constant);
                    var getDeviceIdCallback = function (result) {
                        if (result.length == 0){
                            $timeout(function(){Umeng.getDeviceId(getDeviceIdCallback);}, 1000);
                        }else{
                            config.client.device.IDFA = result;
                        }
                    };
                    Umeng.getDeviceId(getDeviceIdCallback);
                }
            };

            document.addEventListener('deviceready', initUmeng, false);

            $timeout(function () {
                if ($cordovaSplashscreen && navigator.splashscreen){
                    $cordovaSplashscreen.hide();
                }
            }, 300);

            $ionicPlatform.registerBackButtonAction(function (e) {
                if ($ionicHistory.backView()) {
                    if($cordovaKeyboard.isVisible()) {
                        $cordovaKeyboard.close();
                    }else {
                        $ionicHistory.goBack();
                    }
                } else {
                    if ($rootScope.backButtonPressedOnceToExit) {
                        ionic.Platform.exitApp();
                    } else {
                        $rootScope.backButtonPressedOnceToExit = true;
                        $cordovaToast.showShortCenter('再按一次退出APP');
                        setTimeout(function () {
                            $rootScope.backButtonPressedOnceToExit = false;
                        }, 2000);
                    }
                }
                e.preventDefault();
                return false;
            }, 101);

            window.addEventListener('native.keyboardhide',function (e){
                cordova.plugins.Keyboard.isVisible = true;
                $timeout(function() {
                    cordova.plugins.Keyboard.isVisible = false;
                },100);

            });

            var setAppProduct = function(value){
                if (value) {
                    $window.localStorage.setItem("app.product", angular.toJson(value));
                }
            };

            var getAppProduct = function(){
                var params = {};
                params.app_product_key = config.app_product_key;
                params.client = config.client;

                $http({
                    timeout: 5000,
                    method: 'jsonp',
                    url: config.data_domain + "/index.php/app_product/?callback=JSON_CALLBACK",
                    params: params
                })
                    .success(function (response) {
                        if (response.success && response.data) {
                            setAppProduct(config.appProduct);
                            config.appProduct = response.data;
                        }
                    })
                    .error(function (response, status) {
                    })
                    .finally(function () {
                    })
                ;

                if ($window.localStorage.getItem('app.product')){
                    return config.appProduct = angular.fromJson($window.localStorage.getItem('app.product'));
                }
                return false;
            };

            var ls_app_product_key = $window.localStorage.getItem('app_product_key');
            if (ls_app_product_key && ls_app_product_key.toString().trim().length > 17) {
                config.app_product_key = ls_app_product_key;
                config.client.source = ls_app_product_key.substr(17);
            } else {
                if (typeof app_product_key != 'undefined' && app_product_key && app_product_key.toString().trim().length > 17){
                    $window.localStorage.setItem('app_product_key', app_product_key);
                    config.app_product_key = app_product_key;
                    config.client.source = app_product_key.substr(17);
                }
            }

            if (config.client.source==='') {
                var user_source = $window.localStorage.getItem('user.source');
                if (user_source && user_source.toString().trim().length > 1) {
                    config.client.source = user_source;
                } else {
                    user_source = config.client.source;
                    if (user_source && user_source.toString().trim().length > 1) {
                        $window.localStorage.setItem('user.source', user_source);
                    }
                }
            }

            if (config.app_product_key!=''){
                getAppProduct();
            }
        });
    })

    .constant('config', {
        'data_domain': data_domain,
        'assets_domain': assets_domain,
        'assets_img_domain': assets_domain+'/img/',

        'TOKEN_NAME':'__hash__',
        'WELLCOME_TOKEN_NAME':'WELLCOME_TOKEN_NAME',
        '__hash__':'',

        'app_product_key': '',
        'appProduct' : '',

        'client' : {
            'version': '1.0.0',
            'source': '',
            'appName': '',
            'device' : {
                'UUID': '',
                'OS': navigator.userAgent,
                'model': '',
                'IMEI':'',
                'IDFA':''
            }
        },
        'service':
        {
            'weixin': 'huijiekuan',
            'service_qq': 294748749
        },

        'isApple': /\(i[^;]+;( U;)? CPU.+Mac OS X/i.test(navigator.userAgent) || /(iPhone)|(iPod)|(ios)|(mac)|(ipad)|(iwatch)|(apple)/i.test(navigator.userAgent),

    })

;
